#
# map3d4.rb
#
# $Id: map3d4.rb,v 1.1 2000/11/21 03:15:41 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


xmin = -50
xmax = 50
ymin = -50
ymax = 50
vxmin = 0.0
vxmax = 0.8
vymin = 0.0
vymax = 0.8
zmin = -50
zmax = 50
vzmin = 0.0
vzmax = 0.8
xvp3 = 2.5
yvp3 = -1.0
zvp3 = 1.5
xfc3 = (vxmax-vxmin)/2
yfc3 = (vymax-vymin)/2
zfc3 = (vzmax-vzmin)/2

nmax = 40

def aplot(ijk)
  nmax = 40
  x = NArray.sfloat(nmax+1)
  y = NArray.sfloat(nmax+1)

  slpvpr(1)

  dt = 2.0*PI / nmax
  for n in 0..nmax
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  sgplu(nmax+1, x, y)

  dt = 2.0*PI / 3
  for n in 0..3
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  sgplu(4, x, y)

  sgstxs(0.07)
  sgtxu(0.0, 0.0, 'DENNOU')
  cttl= format("%2.2d",ijk)
  sgtxu(0.0, -30.0, cttl)

end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

sgiset('IFONT', 2)

sgfrm

#-- X-Y PLANE ----
sgswnd(xmin, xmax, ymin, ymax)
sgsvpt(vxmin, vxmax, vymin, vymax)
sgstrn(1)
sgstrf

scspln(1, 2, vzmax)
scseye(xvp3, yvp3, zvp3)
scsobj(xfc3, yfc3, zfc3)
scsprj

aplot(1)

#-- X-Z PLANE ----
sgswnd(xmin, xmax, zmin, zmax)
sgsvpt(vxmin, vxmax, vzmin, vzmax)
sgstrn(1)
sgstrf

scspln(1, 3, vymin)
scsprj

aplot(2)

#-- Y-Z PLANE ----
sgswnd(ymin, ymax, zmin, zmax)
sgsvpt(vymin, vymax, vzmin, vzmax)
sgstrn(1)
sgstrf

scspln(2, 3, vxmax)
scsprj

aplot(3)

sgcls
